/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prsem_h___^M
#define prsem_h___^M
^M
/*^M
** API for counting semaphores. Semaphores are counting synchronizing ^M
** variables based on a lock and a condition variable.  They are lightweight ^M
** contention control for a given count of resources.^M
*/^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef struct PRSemaphore PRSemaphore;^M
^M
/*^M
** Create a new semaphore object.^M
*/^M
NSPR_API(PRSemaphore*) PR_NewSem(PRUintn value);^M
^M
/*^M
** Destroy the given semaphore object.^M
**^M
*/^M
NSPR_API(void) PR_DestroySem(PRSemaphore *sem);^M
^M
/*^M
** Wait on a Semaphore.^M
** ^M
** This routine allows a calling thread to wait or proceed depending upon the ^M
** state of the semahore sem. The thread can proceed only if the counter value ^M
** of the semaphore sem is currently greater than 0. If the value of semaphore ^M
** sem is positive, it is decremented by one and the routine returns immediately ^M
** allowing the calling thread to continue. If the value of semaphore sem is 0, ^M
** the calling thread blocks awaiting the semaphore to be released by another ^M
** thread.^M
** ^M
** This routine can return PR_PENDING_INTERRUPT if the waiting thread ^M
** has been interrupted.^M
*/^M
NSPR_API(PRStatus) PR_WaitSem(PRSemaphore *sem);^M
^M
/*^M
** This routine increments the counter value of the semaphore. If other threads ^M
** are blocked for the semaphore, then the scheduler will determine which ONE ^M
** thread will be unblocked.^M
*/^M
NSPR_API(void) PR_PostSem(PRSemaphore *sem);^M
^M
/*^M
** Returns the value of the semaphore referenced by sem without affecting^M
** the state of the semaphore.  The value represents the semaphore vaule^M
F** at the time of the call, but may not be the actual value when the^M
** caller inspects it.^M
*/^M
NSPR_API(PRUintn) PR_GetValueSem(PRSemaphore *sem);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prsem_h___ */^M
