/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prmon_h___^M
#define prmon_h___^M
^M
#include "prtypes.h"^M
#include "prinrval.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
typedef struct PRMonitor PRMonitor;^M
^M
/*^M
** Create a new monitor. Monitors are re-entrant locks with a single built-in^M
** condition variable.^M
**^M
** This may fail if memory is tight or if some operating system resource^M
** is low.^M
*/^M
NSPR_API(PRMonitor*) PR_NewMonitor(void);^M
^M
/*^M
** Destroy a monitor. The caller is responsible for guaranteeing that the^M
** monitor is no longer in use. There must be no thread waiting on the monitor's^M
** condition variable and that the lock is not held.^M
**^M
*/^M
NSPR_API(void) PR_DestroyMonitor(PRMonitor *mon);^M
^M
/*^M
** Enter the lock associated with the monitor. If the calling thread currently^M
** is in the monitor, the call to enter will silently succeed. In either case,^M
** it will increment the entry count by one.^M
*/^M
NSPR_API(void) PR_EnterMonitor(PRMonitor *mon);^M
^M
/*^M
** Decrement the entry count associated with the monitor. If the decremented^M
** entry count is zero, the monitor is exited. Returns PR_FAILURE if the^M
** calling thread has not entered the monitor.^M
*/^M
NSPR_API(PRStatus) PR_ExitMonitor(PRMonitor *mon);^M
^M
/*^M
** Wait for a notify on the monitor's condition variable. Sleep for "ticks"^M
** amount of time (if "ticks" is PR_INTERVAL_NO_TIMEOUT then the sleep is^M
** indefinite).^M
**^M
** While the thread is waiting it exits the monitor (as if it called^M
** PR_ExitMonitor as many times as it had called PR_EnterMonitor).  When^M
** the wait has finished the thread regains control of the monitors lock^M
** with the same entry count as before the wait began.^M
**^M
** The thread waiting on the monitor will be resumed when the monitor is^M
** notified (assuming the thread is the next in line to receive the^M
** notify) or when the "ticks" timeout elapses.^M
**^M
** Returns PR_FAILURE if the caller has not entered the monitor.^M
*/^M
NSPR_API(PRStatus) PR_Wait(PRMonitor *mon, PRIntervalTime ticks);^M
^M
/*^M
** Notify a thread waiting on the monitor's condition variable. If a thread^M
** is waiting on the condition variable (using PR_Wait) then it is awakened^M
** and attempts to reenter the monitor.^M
*/^M
NSPR_API(PRStatus) PR_Notify(PRMonitor *mon);^M
^M
/*^M
** Notify all of the threads waiting on the monitor's condition variable.^M
** All of threads waiting on the condition are scheduled to reenter the^M
** monitor.^M
*/^M
NSPR_API(PRStatus) PR_NotifyAll(PRMonitor *mon);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prmon_h___ */^M
